%RUN BAYESIAN MODEL WITH FACTOR ESTIMATES.
rng(1993);

bPlotIndividualDraws= 0;
iPosteriorDraws     = 2.5*10^3;                             %Specify correct number of simulations in this script.
MktVola_Factor_Bayes;                                       %Draw market volatility factor samples.                                        
mVola_Bayes         = mVola_Bayes(:,setdiff(1:12,[4,8,10]),:,2);      %remove greece, ireland, luxembourg. Retain 10Y bucket only.
clearvars -except mVola_Bayes iPosteriorDraws vDates       %Minimize workspace.


%Plot factor draws
vXticks         = datenum("01-01-2000",'dd-mm-yyyy');
vXticklabels    = "01-00";%"01-01-2000";
for i=2:2:17
    if i<10
        vXticks      = [vXticks;datenum("01-01-200"+i,'dd-mm-yyyy')]; %#ok<*AGROW>
        vXticklabels = [vXticklabels;"01-0"+i]; %[vXticklabels;"01-01-200"+i]; 
    else
        vXticks = [vXticks;datenum("01-01-20"+i,'dd-mm-yyyy')];
        vXticklabels = [vXticklabels;"01-"+i];%[vXticklabels;"01-01-20"+i];
    end        
end
aCountries = ["AT";"BE";"DE";"ES";"FI";"FR";"IT";"NL";"PT"];
figure
for i=1:9
    subplot(5,2,i)
    plot( vDates ,squeeze(mean(mVola_Bayes(:,i,:),3)))
    datetick('x','mm-yy');
    xlim([vDates(1),vDates(end)])
    xticks(vXticks)
    xticklabels(vXticklabels)
    ylim([-1 7])
    title(aCountries(i))
end

if bPlotIndividualDraws == 1
    figure
    for i=1:9
        subplot(5,2,i)
        plot( repmat(vDates,[1 iPosteriorDraws]) ,squeeze(mVola_Bayes(:,i,:)))
        datetick('x','mm-yy');
        xlim([vDates(1),vDates(end)])
        xticks(vXticks)
        xticklabels(vXticklabels)
        xlim([vDates(1) vDates(end)])
        ylim([-1 7])
        title(aCountries(i))
    end
end


%Fixed effects Gibbs with every iteration new factor estimate.
iBurnIn = 500;
%FixedEffects_Bayes_main

