%Omit clear and clc because of the larger script that invokes Bayesianfactor model.
%close all;rng(1993);
load("../../../Data/Yields/aYields_change.mat")
%load("../../../Data/Market Volatility/Factor Analysis/aYields_Vola_Factor_individual.mat")
load("../../aAUC.mat")
load("../../aDH_interp_blackout_diff.mat")
load("../../../Data/Market Conditions/aFinMarket.mat")
%load("../../aMktDepth.mat")


%aYields_Vola = aYields_Vola_Factor_individual;
%clear aYields_Vola_Factor_individual;

aMaturities = ["5Y";"10Y";"30Y"];
aCountries  = aAUC(1,:);
iN          = numel(aCountries);
%vDates      = aAUC{2,1}(:,1);
iDaysBlckOut= 2;

%Specify which countries to include in the regression per maturity.
[~,aCountrySet,~]    = xlsread("../../../Data/CountrySetPerMaturity.xlsx","B1:Z3");
aSetCntry            = cell(3,1);
[~,aSetCntry{1,1},~] = intersect(aCountries,aCountrySet(1,:));   %5-Year maturity.
[~,aSetCntry{2,1},~] = intersect(aCountries,aCountrySet(2,:));   %10-Year maturity.
[~,aSetCntry{3,1},~] = intersect(aCountries,aCountrySet(3,:));   %30-Year maturity.

%Specify locations in the results excel-file for the estimate.
aLoc = ["2";"3";"4";"5";"9";"10";"11";"12"];
iK   = length(aLoc);

%Specify time window around auction. iCentre specifies the location of the
%peak of the auction cycle (0 is auction day itself, positive numbers are days
%after the auction and negative are pre-auction.
%iDays_Pre and iDays_Post specify the time window before and after iCentre.
iCentre    = 0;
iDays_Pre  = 5;
iDays_Post = 5;
iWindow_len= iDays_Pre+iDays_Post;


% Include stuff for writing to Excel file (if using Mac), otherwise,
% xlwrite should be changed to xlswrite.
javaaddpath('../../xlwrite/poi_library/poi-3.8-20120326.jar');
javaaddpath('../../xlwrite/poi_library/poi-ooxml-3.8-20120326.jar');
javaaddpath('../../xlwrite/poi_library/poi-ooxml-schemas-3.8-20120326.jar');
javaaddpath('../../xlwrite/poi_library/xmlbeans-2.3.0.jar');
javaaddpath('../../xlwrite/poi_library/dom4j-1.6.1.jar');
javaaddpath('../../xlwrite/poi_library/stax-api-1.0.1.jar');

aOutput      = cell(2,1);
aOutput{1,1} = "Y";
aOutput{2,1} = "Z";

for bCovariates = 0:1
    if bCovariates
        %Differences for EONIA, Log Differences for Indices.
        mX_covs = [aFinMarket{2,1}(1:end-3,2),log(aFinMarket{2,2}(1:end-3,2)),...
                   log(aFinMarket{2,3}(1:end-3,2)),log(aFinMarket{2,4}(1:end-3,2))];
        %mX_covs = [mX_covs(1,:);diff(mX_covs)]; 
        mX_covs = diff(mX_covs);
        mX_covs(:,2:4) = mX_covs(:,2:4)*100;
        mX_covs = [ones(2,4)*NaN;mX_covs(1:end-1,:)]; %first two lagged differences we don't observe; these observations are filtered out as we drop observations due to auction dummies.
    end
    for m=2:2
        disp('maturity')
        disp(m)
        
        aYields_change_m    = aYields_change(:,aSetCntry{m,1});
        aAUC_m              = aAUC(:,aSetCntry{m,1});
        %aYields_Vola_m      = aYields_Vola(:,aSetCntry{m,1});
        aDH_interp_diff_m   = aDH_interp_blackout_diff(:,aSetCntry{m,1});
        iN                  = numel(aYields_change_m(1,:));
        
        %------Dependent-Variable-----------------------------------------%
        vY_all =[];
        vID    =[];
        for i=1:iN
            vY_diff = aYields_change_m{m+1,i}(:,2)*100;                 %in bps
            iT_total= length(vY_diff);
            vY_all  = [vY_all,vY_diff];                             %#ok<AGROW>
            %vID     = [vID,ones(iT_total,1)*i];                     %#ok<AGROW>
        end
        %-----------------------------------------------------------------%
        
        %------Independent-Variables--------------------------------------%
        mAUC        = zeros(iT_total,iN);
        %mVola       = zeros(iT_total,iN);
        mDH         = zeros(iT_total,iN);
        %mMktDepth   = zeros(iT_total,iN);   
        for i=1:iN
            mAUC(:,i)  = aAUC_m{m+1,i}( 1:iT_total ,2);
            %mVola(:,i) = aYields_Vola_m{m+1,i}( 1:iT_total ,2);
            mDH(:,i)   = max(aDH_interp_diff_m{2,i}( 1:iT_total ,2),0);
            %mMktDepth(:,i) = aMktDepth_m{2,i}( 1:iT_total ,2);%/1000
        end
        %-----------------------------------------------------------------%
        
        %Clear up space before Gibbs sampler
        clear vY_diff aYields_change aYields_change_m aAUC aAUC_m aYields_Vola aYields_Vola_m aDH_interp_blackout_diff aDH_interp_diff_m;
        clear aFinMarket
        clear aCountries aCountrySet aSetCntry
        
        iSim = iPosteriorDraws; %From main 
       
        
        %------Panel-Regression-------------------------------------------%
        %Only retain indices that contain data, i.e. cut out zeros, due to auction cycle lags and leads.
        vIndex_i     = logical([zeros(iDays_Post,1);ones(iT_total-iDays_Pre-iDays_Post+1,1);zeros((iDays_Pre-1),1)]);
        vIndex_allC  = repmat(vIndex_i , [iN 1]);
        iT           = sum(vIndex_i);
        
        vIndxCol             = sort( repmat( 1:iN, [1 iT]));
        mX_intercept_sparse  = sparse(1:iT*iN, vIndxCol, ones(iT*iN,1)); %(row indices, row indices, entries);
        
        vRange_i  = find(vIndex_i)+((iDays_Pre-1):-1:-iDays_Post);            %Range matrix for auction cycle
        vRange_i  = reshape(vRange_i', [iT*10 1]);                              %Reshape to vector to select correct indices out of mAUC
        vRange_i  = single(vRange_i);                                           %save as single to minimize memory usage, DONT save as uint8 numbers as vRange numbers fall outside the range that uint can handle
        
        vRange_allC = find(vIndex_allC)+((iDays_Pre-1):-1:-iDays_Post);
        vRange_allC = reshape(vRange_allC', [iT*iN*10 1]);                              %Reshape to vector to select correct indices out of mAUC
        vRange_allC = single(vRange_allC);
        vAUC_stack  = reshape(mAUC, [length(vIndex_i)*iN 1]);
        
        tic
        mAUC_total    = sum(mAUC,2);
        mX_AUC_sparse = sparse(reshape(vAUC_stack(vRange_allC),[10,length(vRange_allC)/10])'); %correct.
        mX_FAUC_sparse= sparse(repmat(reshape(mAUC_total(vRange_i'),[10,length(vRange_i)/10])',[iN 1])-mX_AUC_sparse); %correct.
        
        
        [vIndxRow, vIndxCol, vX]    = find(mX_AUC_sparse.*reshape( mDH(vIndex_i,:), [iT*iN 1] ) );
        disp(size(mX_AUC_sparse.*reshape( mDH(vIndex_i,:), [iT*iN 1] ) ))
        mX_AUC_DH_sparse            = sparse(vIndxRow,vIndxCol, vX, iT*iN, iWindow_len);
        mX_AUC_DH_sparse            = mX_AUC_DH_sparse(:,[1:3,6:10]);          %Get rid of AUC_t-1*DH_t-1, AUC_t, DH_t interactions (orthogonal)

        [vGridRowDH,vGridColDH]= ndgrid(repmat((1:iT)',[iN 1]),1:size(mX_AUC_DH_sparse,2));
        mX_AUC_DH_total_sparse = accumarray([vGridRowDH(:),vGridColDH(:)],mX_AUC_DH_sparse(:) ); 
        mX_AUC_DH_total_sparse = repmat(mX_AUC_DH_total_sparse,[iN 1]);
        mX_FAUC_DH_sparse      = mX_AUC_DH_total_sparse-mX_AUC_DH_sparse;
        
        
        cX_AUC_VOL_sparse           = cell   (1    , iSim );
        cX_AUC_VOL_DH_sparse        = cell   (1    , iSim );
        cX_FAUC_VOL_sparse          = cell   (1    , iSim );
        cX_FAUC_VOL_DH_sparse       = cell   (1    , iSim );
        
        [vIndxRowVol, vIndxColVol, ~]= find(mX_AUC_sparse); %mX_AUC same entry locations and size as mX_AUC_VOL
        [vGridRowVol,vGridColVol]    = ndgrid(repmat((1:iT)',[iN 1]),1:size(mX_AUC_sparse,2)); 
        [vIndxRowDH, vIndxColDH, ~]  = find(mX_AUC_DH_sparse);
        for s=1:iSim
            %Domestic
            mX_AUC_VOL_s    = mX_AUC_sparse.* reshape( mVola_Bayes(vIndex_i,:,s), [iT*iN 1] );
            cX_AUC_VOL_sparse{1,s} = mX_AUC_VOL_s;
            
            mX_AUC_VOL_DH_s = mX_AUC_sparse.* reshape( mVola_Bayes(vIndex_i,:,s), [iT*iN 1] ).*reshape( mDH(vIndex_i,:), [iT*iN 1] ) ;
            cX_AUC_VOL_DH_sparse{1,s} = mX_AUC_VOL_DH_s;
            cX_AUC_VOL_DH_sparse{1,s}=cX_AUC_VOL_DH_sparse{1,s}(:,[1:3,6:10]); %Get rid of AUC_t-1*DH_t-1, AUC_t, DH_t interactions (orthogonal)
            
            %Total
            mX_AUC_VOL_total_sparse    = accumarray([vGridRowVol(:),vGridColVol(:)],cX_AUC_VOL_sparse{1,s}(:) ); %sum mX_AUC_VOL over i to get total
            mX_AUC_VOL_total_sparse    = repmat(mX_AUC_VOL_total_sparse,[iN 1]);                                 %total is the same for all countries
            mX_AUC_VOL_DH_total_sparse = accumarray([vGridRowDH(:),vGridColDH(:)],cX_AUC_VOL_DH_sparse{1,s}(:) ); %idem
            mX_AUC_VOL_DH_total_sparse = repmat(mX_AUC_VOL_DH_total_sparse,[iN 1]);
        
            %Foreign: total minus domestic
            cX_FAUC_VOL_sparse{1,s}    = mX_AUC_VOL_total_sparse-cX_AUC_VOL_sparse{1,s};
            cX_FAUC_VOL_DH_sparse{1,s} = mX_AUC_VOL_DH_total_sparse-cX_AUC_VOL_DH_sparse{1,s};
            
        end
        %mX_Covariates =repmat([mVola_Bayes(vIndex_i,:,1),mDH_sc(vIndex_i,:),mVola_Bayes(vIndex_i,:,1).*mDH_sc(vIndex_i,:)] ,[iN 1]);
        mX_VOL_allC     = repmat(mVola_Bayes(vIndex_i,:,:),[iN 1 1]);
        mX_DH_allC      = repmat(mDH(vIndex_i,:,:),[iN 1]);
        mX_VOL_DH_allC  = mX_VOL_allC.*repmat(mX_DH_allC,[1 1 iSim]);
        disp(toc)
        
        vY_all  = vY_all(vIndex_allC);                             %#ok<*FNDSB>
        %vID     = vID(vIndex);
        
        clear mAUC mAUC_total mVola mVola_Bayes mDH mDH_sc vAUC_stack;
        clear mX_AUC_VOL_s mX_AUC_VOL_DH_s;
        clear mX_AUC_VOL_total_sparse mX_AUC_VOL_total_sparse mX_AUC_VOL_DH_total_sparse mX_AUC_VOL_DH_total_sparse;
        clear vGridRowVol vGridColVol vGridRowDH vGridColDH;
        clear vID vRange_i vRange_allC vIndex_i vIndex_allC vMatIndx vX;
        %-----------------------------------------------------------------%
 
        %------Panel-Results----------------------------------------------%
        disp('start')
        tic;
        [aBeta, aSigma ] = FixedEffects_Bayes_Gibbs( vY_all,mX_intercept_sparse,mX_AUC_sparse,cX_AUC_VOL_sparse,mX_AUC_DH_sparse,cX_AUC_VOL_DH_sparse,...
        mX_FAUC_sparse,cX_FAUC_VOL_sparse,mX_FAUC_DH_sparse,cX_FAUC_VOL_DH_sparse,...
        mX_VOL_allC,mX_DH_allC,mX_VOL_DH_allC,iSim, [], [] );
        fprintf('ended, time: %.3f\n', toc);
        %aBeta = aBeta(:,:,501:1:end);
        disp(mean(aBeta,3));
        figure
        plot(repmat( (1:size(aBeta,1))', [1 3]), [mean(aBeta,3),mean(aBeta,3)-std(aBeta,[],3),mean(aBeta,3)+std(aBeta,[],3)])
        %-----------------------------------------------------------------%
        
        %------Write-Results----------------------------------------------%
        mLoc1 =[iN+1,iN+1+(iDays_Pre-1)+iCentre;... %10
               iN+11,iN+11+(iDays_Pre-1)+iCentre;... %10
               iN+21,iN+21+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+29,iN+29+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+37,iN+37+(iDays_Pre-1)+iCentre;... %10
               iN+47,iN+47+(iDays_Pre-1)+iCentre;... %10
               iN+57,iN+57+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+65,iN+65+(iDays_Pre-1-iDaysBlckOut)+iCentre];
        mLoc2 = [iN+1+(iDays_Pre-1)+iCentre+1,iN+10;...%10
                iN+11+(iDays_Pre-1)+iCentre+1,iN+20;...%10
                iN+21+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+28;...%8
                iN+29+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+36;...%8
                iN+37+(iDays_Pre-1)+iCentre+1,iN+46;...%10
                iN+47+(iDays_Pre-1)+iCentre+1,iN+56;...%10
                iN+57+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+64;...%8
                iN+65+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+72];%8
         
         sNames = ["AC";"AC\timesVOL";"AC\timesDH";"AC\timesVOL\timesDH";...
                   "ACF";"ACF\timesVOL";"ACF\timesDH";"ACF\timesVOL\timesDH"];
         figure
         for k = 1:iK
            vRange = (iBurnIn:1:iPosteriorDraws);
            vEst= sum(aBeta(mLoc1(k,1):mLoc1(k,2),1,vRange)) - ...
                  sum(aBeta(mLoc2(k,1):mLoc2(k,2),1,vRange)) ;
            
              fprintf('%.2f & %.2f\n',mean(vEst), std(vEst))
            
            subplot(iK/2,2,k)
            histfit(squeeze(vEst))
            title(sNames(k))
         end
        %-----------------------------------------------------------------%
    end
end