%Create individual volatility for country i by estimating the factor model on all
%countries except i, this ensures that the measure does not become endogenous.
%iPosteriorDraws = 12.5*10^3+5000; From main file.
iBurnIn         = 5000;
iThin           = 5;
iSim            = iPosteriorDraws*iThin+ iBurnIn;
sFilepath       = '../../../Data/Yields/Yields.xlsx';

[~,aCountrySet,~] = xlsread("../../../Data/CountrySetPerMaturity.xlsx","B1:Z3");
[~,aSheets]       = xlsfinfo(sFilepath);
aCountries        = aSheets;
iN                = numel(aCountries);
vDates            = x2mdate(xlsread(sFilepath,aSheets{1},'A2:A4954'));
vDates_ECB        = x2mdate(xlsread("../../../Data/Market Conditions/EONIA.xlsx",'A6:A4870'),0);%We stick to the calendar of the ECB.
vDates_miss       = setdiff(vDates,vDates_ECB);
vIndex            = zeros(length(vDates_miss),1);
for i=1:length(vDates_miss)
    vIndex(i) = find(vDates==vDates_miss(i));
end
vDates  = vDates(setdiff(1:size(vDates,1),vIndex),:);
iT      = length(vDates);

vMaturities = [5;10;30];
mVola_Bayes = zeros(iT,iN,(iSim-iBurnIn)/iThin,length(vMaturities)); %slighly different form than rest of the programs to pass it to Bayesian Estimation.
vN          = zeros(3,1);

for m=2:2%1:length(vMaturities)
    mSqDevFromMean =[];
    aCountrySet_m  = aCountrySet(m,:);
    vN(m)          = numel(aCountrySet_m(~cellfun('isempty',aCountrySet_m)));
    for i = 1:vN(m)
        mData           = xlsread(sFilepath,aCountrySet{m,i},'B2:D4954');
        mData2          = mData(setdiff(1:size(mData,1),vIndex),:);
        vY_diff         = diff([mData(1,m);mData2(:,m)])*100;
        mSqDevFromMean  = [mSqDevFromMean, (vY_diff-mean(vY_diff)).^2]; %#ok<AGROW>
    end
    mIndxx = zeros(vN(m),vN(m)-1);
    for i = 1:vN(m)
        mIndxx(i,:) = find(1:vN(m)~=i);
    end
    
    mAbsDevFromMean = sqrt(mSqDevFromMean);
    mAbsDevFromMean_noncentered = mAbsDevFromMean;
    mAbsDevFromMean = mAbsDevFromMean_noncentered-mean(mAbsDevFromMean_noncentered,1);
    for i = 1:vN(m)
        fprintf('Country %i:\n',i)
        iLoc = find(contains(aCountries,aCountrySet_m(i)));
        disp(aCountries(iLoc));
        disp(mIndxx(i,:))
        disp('start')
        tic;
        [ aLambda, aSigma, aFactor ] = Factor_Gibbs_givenK( mAbsDevFromMean(:,mIndxx(i,:)), 1, iSim );
        fprintf('ended, time: %.3f\n', toc);
        
        aFactor = aFactor(:,:,iBurnIn+1:iThin:end); %5k burnin, thin factor 5.
        
        mVola_Bayes(:,iLoc,:,m) = aFactor;
    end  
end
%save('aYields_Vola_Factor_individual_bayes.mat', 'aYields_Vola_Factor_individual_bayes');
%save('aYields_Vola_Factor_individual_bayes.mat', 'aYields_Vola_Factor_individual_bayes', '-v7.3');