clear;clc;close all;
load("../../../Data/Yields/aYields_change.mat")
load("../../../Data/Market Volatility/Factor Analysis/aYields_Vola_Factor_individual.mat")
load("../../aAUC.mat")
load("../../aAC.mat")
load("../../aDH_interp_blackout_diff.mat")
load("../../aMktDepth.mat")
load("../../../Data/Market Conditions/aFinMarket.mat")


aYields_Vola = aYields_Vola_Factor_individual;
clear aYields_Vola_Factor_individual;

aMaturities = ["5Y";"10Y";"30Y"];
aCountries  = aAUC(1,:);
iN          = numel(aCountries);
vDates      = aAUC{2,1}(:,1);
iDaysBlckOut= 2; %pre auction and auction day.

%Specify which countries to include in the regression per maturity.
[~,aCountrySet,~]    = xlsread("../../../Data/CountrySetPerMaturity.xlsx","B1:Z3");
aSetCntry            = cell(3,1);
[~,aSetCntry{1,1},~] = intersect(aCountries,aCountrySet(1,:));   %5-Year maturity.
[~,aSetCntry{2,1},~] = intersect(aCountries,aCountrySet(2,:));   %10-Year maturity.
[~,aSetCntry{3,1},~] = intersect(aCountries,aCountrySet(3,:));   %30-Year maturity.

%Specify locations in the results excel-file for the estimate.
aLoc = ["2";"3";"4";"5";"7";... %DOM
        "9";"10";"11";"12";"14"]; %FOR
iK   = length(aLoc);

%Specify time window around auction. iCentre specifies the location of the
%peak of the auction cycle (0 is auction day itself, positive numbers are days
%after the auction and negative are pre-auction.
%iDays_Pre and iDays_Post specify the time window before and after iCentre.
iCentre    = 0;
iDays_Pre  = 5;
iDays_Post = 5;
iWindow_len= iDays_Pre+iDays_Post;
bTrend     = 0;

%Include stuff for writing to Excel file (if using Mac), otherwise,
% xlwrite should be changed to xlswrite.
javaaddpath('../../xlwrite/poi_library/poi-3.8-20120326.jar');
javaaddpath('../../xlwrite/poi_library/poi-ooxml-3.8-20120326.jar');
javaaddpath('../../xlwrite/poi_library/poi-ooxml-schemas-3.8-20120326.jar');
javaaddpath('../../xlwrite/poi_library/xmlbeans-2.3.0.jar');
javaaddpath('../../xlwrite/poi_library/dom4j-1.6.1.jar');
javaaddpath('../../xlwrite/poi_library/stax-api-1.0.1.jar');

aOutput      = cell(2,1);
aOutput{1,1} = "F";
aOutput{2,1} = "G";


iLoc_QE     = find(vDates == datenum('10-05-2010', 'dd-mm-yyyy')); %Start SMP.
vDates_QE   = vDates(iLoc_QE:end-3); %yield data only goes until 27th dec. skip last 3.

bTrend = 0;
for bCovariates = 0:1
    if bCovariates
        %Differences for EONIA, Log Differences for Indices.
        mX_covs = [aFinMarket{2,1}(iLoc_QE:iLoc_QE+iT_total-1,2),log(aFinMarket{2,2}(iLoc_QE:iLoc_QE+iT_total-1,2)),...
                   log(aFinMarket{2,3}(iLoc_QE:iLoc_QE+iT_total-1,2)),log(aFinMarket{2,4}(iLoc_QE:iLoc_QE+iT_total-1,2))];
        mX_covs = diff(mX_covs);
        mX_covs(:,2:4) = mX_covs(:,2:4)*100; %bps
        mX_covs = [ones(2,4)*NaN;mX_covs(1:end-1,:)]; %first two lagged differences we don't observe; these observations are filtered out as we drop observations due to auction dummies.
    end
    for m=2:2
        disp('maturity')
        disp(m)
        
        aYields_change_m    = aYields_change(:,aSetCntry{m,1});
        aAUC_m              = aAUC(:,aSetCntry{m,1});
        aAC_m               = aAC(:,aSetCntry{m,1});
        aYields_Vola_m      = aYields_Vola(:,aSetCntry{m,1});
        aDH_interp_diff_m   = aDH_interp_blackout_diff(:,aSetCntry{m,1});
        aMktDepth_m         = aMktDepth(:,aSetCntry{m,1});
        iN                  = numel(aYields_change_m(1,:));
        
        %------Dependent-Variable-----------------------------------------%
        vY_all =[];
        vID    =[];
        for i=1:iN
            vY_diff = aYields_change_m{m+1,i}(iLoc_QE:end,2)*100;                 %in bps
            iT_total= length(vY_diff);
            vY_all  = [vY_all,vY_diff];                             %#ok<AGROW>
            vID     = [vID,ones(iT_total,1)*i];                     %#ok<AGROW>
        end
        %-----------------------------------------------------------------%
        
        %------Independent-Variables--------------------------------------%
        mAUC        = zeros(iT_total,iN);
        mVola       = zeros(iT_total,iN);
        mDH         = zeros(iT_total,iN);
        mMktDepth   = zeros(iT_total,iN);
       for i=1:iN
            mAUC(:,i)  = aAUC_m{m+1,i}( iLoc_QE:iLoc_QE+iT_total-1 ,2);
            mVola(:,i) = aYields_Vola_m{m+1,i}( iLoc_QE:iLoc_QE+iT_total-1 ,2);
            mDH(:,i)   = max(aDH_interp_diff_m{2,i}( iLoc_QE:iLoc_QE+iT_total-1 ,2),0);
            mMktDepth(:,i)  = aMktDepth_m{2,i}( iLoc_QE:iLoc_QE+iT_total-1 ,2)/1000; 
       end
        mAUC_total = sum(mAUC,2);
        %-----------------------------------------------------------------%
        mAC = cell2mat(aAC_m(m+1,:));
        mAC = mAC(:,(2:2:iN*2));

        %------Panel-Regression-------------------------------------------%
        mX =[];
        for i=1:iN
            if bTrend
                mX_i            = zeros(iT_total,iN +iK*iWindow_len +4*iN +iWindow_len*2 +1);
            else
                mX_i            = zeros(iT_total,iN +iK*iWindow_len +4*iN );
            end
            vIntercept      = zeros(iN,1);
            vIntercept(i)   = 1;
            for t=1+iDays_Post:iT_total-(iDays_Pre-1)
                vRange       = t+(iDays_Pre-1):-1:t-iDays_Post;
                vX_dom       = mAUC(vRange,i);
                vX_dom_VOL   = vX_dom.*mVola(t,i);
                vX_dom_DH    = vX_dom.*mDH(t,i);
                vX_dom_VOL_DH= vX_dom.*mDH(t,i).*mVola(t,i);
                vX_dom_mkt   = vX_dom.* mMktDepth(t,i); 
                
                vX_for       = (mAUC_total(vRange)-vX_dom);
                vX_for_VOL   = sum(mAUC(vRange,1:end~=i).*mVola(t,1:end~=i),2);
                vX_for_DH    = sum(mAUC(vRange,1:end~=i).*mDH(t,1:end~=i),2);
                vX_for_VOL_DH= sum(mAUC(vRange,1:end~=i).*mDH(t,1:end~=i).*mVola(t,1:end~=i),2);
                vX_for_mkt   = sum(mAUC(vRange,1:end~=i).*mMktDepth(t,1:end~=i),2);
                
                if bTrend
                    mX_i(t,:)   = [vIntercept',...
                        vX_dom',vX_dom_VOL',vX_dom_DH',vX_dom_VOL_DH',vX_dom_mkt',...
                        vX_for',vX_for_VOL',vX_for_DH',vX_for_VOL_DH',vX_for_mkt',...
                        mVola(t,:),mDH(t,:),mVola(t,:).*mDH(t,:),mMktDepth(t,:),vX_dom'*t,vX_for'*t,t];
                else
                    mX_i(t,:)   = [vIntercept',...
                        vX_dom',vX_dom_VOL',vX_dom_DH',vX_dom_VOL_DH',vX_dom_mkt',...
                        vX_for',vX_for_VOL',vX_for_DH',vX_for_VOL_DH',vX_for_mkt',...
                        mVola(t,:),mDH(t,:),mVola(t,:).*mDH(t,:),mMktDepth(t,:)];
                end
            end
            if ~bCovariates
                mX = [mX;mX_i];                                 %#ok<AGROW>
            else
                mX = [mX;[mX_i,mX_covs]];                       %#ok<AGROW>
            end
        end
        %Only retain indices that contain data, i.e. cut out zeros.
        vIndex_i = [zeros(iDays_Post,1);ones(iT_total-iDays_Pre-iDays_Post+1,1);zeros((iDays_Pre-1),1)];
        vIndex   = repmat(vIndex_i , [iN 1]);
        
        vY_all = vY_all(find(vIndex));                             %#ok<*FNDSB>
        vID    = vID(find(vIndex));
        %mX     = mX(find(vIndex),:);
        
        mX     = mX(find(vIndex),setdiff((1:size(mX,2)),iN+[24,25,34,35,74,75,84,85])); %Get rid of AUC_t-1*DH_t-1, AUC_t, DH_t interactions (orthogonal)
        iT     = sum(vIndex_i);
        %-----------------------------------------------------------------%
       
        
        %------Panel-Results----------------------------------------------%
        vBeta  = lsqlin(mX, vY_all,[],[], [],[],[],[]);%lsqlin(mX, vY_all,[],[], mConstr, zeros(iK*(iWindow_len-1),1),[],[]);
        vResid = vY_all-mX*vBeta;
        
        dSSR    = vResid'*vResid;
        dSST    = (vY_all-mean(vY_all))'*(vY_all-mean(vY_all));
        dR2_adj = R2_adjusted( dSSR, dSST, iT*iN, size(mX,2) );
        
        %Born Breitung (2016)
        [dBB_Stat, dBB_PVal] = Autocorrelation_BornBreitung(iN,iT,vResid);
        
        %C.B. Hansen (2007)
        [mCov, ~, ~] = SandwichCovariance_Arellano(size(mX,2),iN,iT,vResid,mX); %size(mX,2) = iWindow_len*ik+iN
        %-----------------------------------------------------------------%
        
        %------Write-Results----------------------------------------------%
        mLoc1 =[iN+1,iN+1+(iDays_Pre-1)+iCentre;... %10 DOM
               iN+11,iN+11+(iDays_Pre-1)+iCentre;... %10
               iN+21,iN+21+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+29,iN+29+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+37,iN+37+(iDays_Pre-1)+iCentre;... %10
               iN+47,iN+47+(iDays_Pre-1)+iCentre;... %10 FOR
               iN+57,iN+57+(iDays_Pre-1)+iCentre;... %10
               iN+67,iN+67+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+75,iN+75+(iDays_Pre-1-iDaysBlckOut)+iCentre;... %8
               iN+83,iN+83+(iDays_Pre-1)+iCentre]; %10
        mLoc2 = [iN+1+(iDays_Pre-1)+iCentre+1,iN+10;...%10 DOM
                iN+11+(iDays_Pre-1)+iCentre+1,iN+20;...%10
                iN+21+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+28;...%8
                iN+29+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+36;...%8
                iN+37+(iDays_Pre-1)+iCentre+1,iN+46;...%10
                iN+47+(iDays_Pre-1)+iCentre+1,iN+56;...%10 FOR
                iN+57+(iDays_Pre-1)+iCentre+1,iN+66;...%10
                iN+67+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+74;...%8
                iN+75+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+82;...%8
                iN+83+(iDays_Pre-1-iDaysBlckOut)+iCentre+1,iN+92];%10
        for k = 1:iK
            
            dEst= sum(vBeta(mLoc1(k,1):mLoc1(k,2))) - ...
                  sum(vBeta(mLoc2(k,1):mLoc2(k,2))) ;
            
            mR = zeros(1,length(vBeta));
            vR = 0;
            mR(mLoc1(k,1):mLoc1(k,2))   = ones(1,mLoc1(k,2)-mLoc1(k,1)+1);
            mR(mLoc2(k,1):mLoc2(k,2))   = -ones(1,mLoc2(k,2)-mLoc2(k,1)+1);
            
            [dF,dPVal] = FtestHansen(vBeta,mCov,mR,vR,iN,length(vR));
            sLoc       = aLoc(k);
            xlwrite("Panel_results.xlsx", Write_significance(dEst, dPVal),...
                aMaturities(m),aOutput{1+bCovariates,1}+sLoc);
  
            if k == 1 || k == (iK/2 + 1) %Test the domestic and foreign cycle on symmetry
                dEst= sum(vBeta(mLoc1(k,1):mLoc1(k,2))) + ...
                sum(vBeta(mLoc2(k,1):mLoc2(k,2))) ; %Keep this format, not sum over the whole window, but two sums. If we alter centrality, this method accounts for it
                
                mR = zeros(1,length(vBeta));
                vR = 0;
                mR(mLoc1(k,1):mLoc1(k,2))   = ones(1,mLoc1(k,2)-mLoc1(k,1)+1);
                mR(mLoc2(k,1):mLoc2(k,2))   = ones(1,mLoc2(k,2)-mLoc2(k,1)+1);
                
                [dF,dPVal] = FtestHansen(vBeta,mCov,mR,vR,iN,length(vR));
                %Symmetry
                sLoc = 26; %excel sheet output location
                if k == (iK/2 + 1)
                    sLoc = 27;
                end
                xlwrite("Panel_results.xlsx", Write_significance(dEst, dPVal),...
                    aMaturities(m),aOutput{1+bCovariates,1}+sLoc);
            end
        end
        
        if bTrend
            dEst        = vBeta(end-5);
            mR          = zeros(1,length(vBeta));
            vR          = 0;
            mR(end-5)   = 1;
            [dF,dPVal]  = FtestHansen(vBeta,mCov,mR,vR,iN,length(vR));
            xlwrite("Panel_results.xlsx", Write_significance(dEst, dPVal),...
                    aMaturities(m),aOutput{1+bCovariates,1}+15);
        end
        
        if bCovariates
            for i=1:4
                dEst        = vBeta(end-4+i);
                mR          = zeros(1,length(vBeta));
                vR          = 0;
                mR(end-4+i) = 1;
                [dF,dPVal]  = FtestHansen(vBeta,mCov,mR,vR,iN,length(vR));
                xlwrite("Panel_results.xlsx", Write_significance(dEst, dPVal),...
                    aMaturities(m),aOutput{1+bCovariates,1}+(i+15));
            end
        end
        
        sLoc = "21";
        xlwrite("Panel_results.xlsx", Write_significance(dBB_Stat, dBB_PVal),aMaturities(m),aOutput{1+bCovariates,1}+sLoc);
        sLoc = "22";
        xlwrite("Panel_results.xlsx", dR2_adj,aMaturities(m),aOutput{1+bCovariates,1}+sLoc);
        sLoc = "23";
        xlwrite("Panel_results.xlsx", iT,aMaturities(m),aOutput{1+bCovariates,1}+sLoc);
        sLoc = "24";
        xlwrite("Panel_results.xlsx", iN,aMaturities(m),aOutput{1+bCovariates,1}+sLoc);
        %-----------------------------------------------------------------%
    end
end