%Read Data from excel files and save as .mat
clear;clc;close all;
load("../Yields/aYields_change.mat") %3 obs diff with eurostoxx dataset due to 3 missing at end of sample in yield data set. 27,28,29 dec 2017

aFinMarket = cell(2,4);
aFinMarket{1,1} = 'EONIA';
aFinMarket{1,2} = 'Euro Stoxx 50';
aFinMarket{1,3} = 'Euro Stoxx Bank';
%aFinMarket{1,4} = 'VIX'; VSTOXX!!
aFinMarket{1,4} = 'VSTOXX';

vDates_Eonia    = x2mdate(xlsread('EONIA.xlsx','A6:A4870'),0);
vEonia          = xlsread('EONIA.xlsx','B6:B4870');
vVSTOXX         = xlsread('VSTOXX_imputed.xlsx','C2:C4866'); % VSTOXX_imputed have same dates as eonia file.

aFinMarket{2,1} = [vDates_Eonia,vEonia];
aFinMarket{2,4} = [vDates_Eonia,vVSTOXX];

vDates_Eurostoxx = x2mdate(xlsread('EuroStoxx_VIX.xlsx','A2358:A7312'),0);
vEurostoxx50     = xlsread('EuroStoxx_VIX.xlsx','D2358:D7312');
vEurostoxxBank   = xlsread('EuroStoxx_VIX.xlsx','B2358:B7312');

vDates_miss = setdiff(vDates_Eurostoxx,vDates_Eonia);
vIndex = zeros(length(vDates_miss),1);
for i=1:length(vDates_miss)
    vIndex(i) = find(vDates_Eurostoxx==vDates_miss(i));
end
iIndex_keep = setdiff(1:length(vDates_Eurostoxx),vIndex)';

vEurostoxx50    = vEurostoxx50(iIndex_keep);
vEurostoxxBank  = vEurostoxxBank(iIndex_keep);
aFinMarket{2,2} = [vDates_Eonia,vEurostoxx50];
aFinMarket{2,3} = [vDates_Eonia,vEurostoxxBank];


save('aFinMarket.mat', 'aFinMarket')

figure 
subplot(4,1,1)
plot(vDates_Eonia,vEonia)
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('EONIA')
subplot(4,1,2)
plot(vDates_Eonia,vEurostoxx50)
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('Euro Stoxx 50')
subplot(4,1,3)
plot(vDates_Eonia,vEurostoxxBank)
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('Euro Stoxx Bank Index')
subplot(4,1,4)
plot(vDates_Eonia,vVSTOXX)
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('VSTOXX')

figure 
subplot(4,1,1)
plot(vDates_Eonia(2:end),diff(vEonia))
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('EONIA')
subplot(4,1,2)
plot(vDates_Eonia(2:end),diff(vEurostoxx50))
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('Euro Stoxx50')
subplot(4,1,3)
plot(vDates_Eonia(2:end),diff(vEurostoxxBank))
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('Euro Stoxx Bank Index')
subplot(4,1,4)
plot(vDates_Eonia(2:end),diff(vVSTOXX))
datetick('x','mm-yy')
xlim([vDates_Eonia(1) vDates_Eonia(end)])
title('VSTOXX')