%Create individual volatility for country i by estimating the factor model on all
%countries except i, this ensures that the measure does not become
%endogenous.
%clear; clc;rng(1993);
path_file   = '../../Yields/Yields.xlsx';

[~,aCountrySet,~] = xlsread("../../CountrySetPerMaturity.xlsx","B1:Z3");
[~,aSheets] = xlsfinfo(path_file);
aCountries  = aSheets;
iN          = numel(aCountries);
vDates      = x2mdate(xlsread(path_file,aSheets{1},'A2:A4954'));
%vDates      = x2mdate(xlsread(path_file,aSheets{1},'A2:A5376'));

%We stick to the calendar of the ECB, the original files of Jesper contain
%holidays such as Christmas and Eastern. On such days markets are closed
%and only add noise to the analysis.
vDates_ECB  = x2mdate(xlsread("../../Market Conditions/EONIA.xlsx",'A6:A4870'),0);
%vDates_ECB  = x2mdate(xlsread("../../Market Conditions/EONIA.xlsx",'A6:A5380'),0);
vDates_miss = setdiff(vDates,vDates_ECB);
vIndex      = zeros(length(vDates_miss),1);
for i=1:length(vDates_miss)
    vIndex(i) = find(vDates==vDates_miss(i));
end
vDates = vDates(setdiff(1:size(vDates,1),vIndex),:);

vMaturities = [5;10;30];
aYields_Vola_Factor_individual_bayes= cell(4,iN);
aYields_Vola_Factor_individual_bayes(1,:) = aCountries;

vN = zeros(3,1);
for m=2:2%1:length(vMaturities)
    mSqDevFromMean =[];
    aCountrySet_m  = aCountrySet(m,:);
    vN(m)          = numel(aCountrySet_m(~cellfun('isempty',aCountrySet_m)));
    for i = 1:vN(m)
        mData           = xlsread(path_file,aCountrySet{m,i},'B2:D4954');
        mData2          = mData(setdiff(1:size(mData,1),vIndex),:);
        vY_diff         = diff([mData(1,m);mData2(:,m)])*100;
        mSqDevFromMean  = [mSqDevFromMean, (vY_diff-mean(vY_diff)).^2]; %#ok<AGROW>
    end
    mIndxx = zeros(vN(m),vN(m)-1);
    for i = 1:vN(m)
        mIndxx(i,:) = find(1:vN(m)~=i);
    end
    
    mAbsDevFromMean = sqrt(mSqDevFromMean);
    mFactor = zeros(size(mAbsDevFromMean,1),vN(m),400);
    vLoc_inverted = zeros(1,vN(m));
    mNormalFactorModel = [];
    vTime = [];
    mAbsDevFromMean_noncentered = mAbsDevFromMean;
    mAbsDevFromMean = mAbsDevFromMean - mean(mAbsDevFromMean_noncentered,1);
    for i = 1:vN(m)
        fprintf('Country %i\n',i)
        %[~,~,~,~,vFactor1] = factoran(sqrt(mSqDevFromMean(:,(1:vN(m))~=i)),1);
        [~,~,~,~,vFactor1] = factoran(mAbsDevFromMean(:,(1:vN(m))~=i),1);
        mNormalFactorModel = [mNormalFactorModel,vFactor1]; %#ok<AGROW>
        disp('start')
        tic;
        %Data file too large if too many regressions
        %[ aLambda, aSigma, aFactor ] = FactorGibbs_givenK( mAbsDevFromMean(:,mIndxx(i,:)), 1, 255*10^3+5000, 5000, 1 );
        %[ aLambda, aSigma, aFactor ] = FactorGibbs_givenK( mAbsDevFromMean(:,mIndxx(i,:)), 1, 30*10^3+5000, 5000, 1 );
        [ aLambda, aSigma, aFactor ] = FactorGibbs_givenK( mAbsDevFromMean(:,mIndxx(i,:)), 1, 2*10^3+5000, 5000, 1 );
        vTime = [vTime,toc]; %#ok<AGROW>
        fprintf('ended, time: %.3f\n', vTime(end));
        
        aFactor = aFactor(:,:,5001:5:end); %5k burnin, thin factor 5.
        %a(i).Factor = aFactor;
        iLoc = find(contains(aCountries,aCountrySet_m(i)));
        aYields_Vola_Factor_individual_bayes{m+1,iLoc} = aFactor; %[vDates,vFactor];
        
        mFactor(:,i,:) = aFactor;
        
        %if mean(mean(aFactor,3),1)<0 %Doesnt work with centered data. check the peak
        if abs(min(mean(aFactor,3)))> max(mean(aFactor,3)) %so if the peak of is in the negative territory, its inverted.
            vLoc_inverted(i) = 1;
        end
        %figure
        %subplot(3,1,1)
        %plot(repmat((1:length(vFactor1))',[1 2]), [vFactor1/norm(vFactor1) , (mean(aFactor,3)-mean(mean(aFactor,3)))/norm(mean(aFactor,3))])
        %subplot(3,1,2)
        %plot((1:length(vFactor1))',vFactor1)
        %subplot(3,1,3)
        %plot((1:length(vFactor1))',mean(aFactor,3))
        %plot(repmat((1:length(vFactor1))',[1 3]),[mean(aFactor,3),mean(aFactor,3)-3*std(aFactor,[],3),mean(aFactor,3)+3*std(aFactor,[],3)])
        %cc
    end
    disp('Time')
    disp(vTime)
    disp('Average Time')
    disp(mean(vTime))
    
    close all
    plot(mean(mFactor,3))
    disp('which are inverted?')
    %vLoc_inverted = find(mean(mean(mFactor,3),1)<0);
    disp(vLoc_inverted);
    vLoc_inverted_indx = find(vLoc_inverted);
    figure
    subplot(3,1,1)
    plot(squeeze(mFactor(:,vLoc_inverted_indx(1),:)))
    subplot(3,1,2)
    plot(mNormalFactorModel(:,vLoc_inverted_indx(1)))
    subplot(3,1,3)
    plot(repmat((1:4862)', [1 2]),[-mean(mFactor(:,vLoc_inverted_indx(1),:),3),mNormalFactorModel(:,vLoc_inverted_indx(1))])
    legend(["Bayes inverted";"Normal Factor"])
end





%save('aYields_Vola_Factor_individual_bayes.mat', 'aYields_Vola_Factor_individual_bayes');
%save('aYields_Vola_Factor_individual_bayes.mat', 'aYields_Vola_Factor_individual_bayes', '-v7.3');